
#include <pspkernel.h>
#include <pspdebug.h>
#include <pspiofilemgr.h>
#include <pspdisplay.h>
#include <psppower.h>
#include <string.h>
#include <limits.h>
#include <errno.h>
#include <pspaudiolib.h>
#include <GL/glut.h>    
#include <GL/gl.h>
#include <GL/glu.h>	
#include <stdio.h>      
#include <stdlib.h>    
#include <time.h> 
#include "mp3player.h"
#include "glPrint.h"
#include "md2.h"

glPrint * cadena;

int inicio_ani=1,fin_ani=39;

char buf[16];

char Nombrejuego[20];

CMD2Model * modelo;
CMD2Model * modelo_w;

struct timeval frameStartTime, frameEndTime;

void frameStart(void) {
  gettimeofday(&frameStartTime, NULL);
}

void frameEnd(void){
  float elapsedTime; 
  gettimeofday(&frameEndTime, NULL);
  elapsedTime= frameEndTime.tv_sec - frameStartTime.tv_sec +((frameEndTime.tv_usec - frameStartTime.tv_usec)/1.0E6);
  sprintf(buf, "fps: %2.0f", 1.0/elapsedTime);
}

int window; 

float xrot, yrot, zrot;

struct Principal{
       int x;
       int y;
       int orientacion;
};
typedef struct Principal Protagonista;

Protagonista p;

void InitGL(int Width, int Height)	     
{
    glEnable(GL_TEXTURE_2D);			
    glClearColor(0,0,0,0);
    glClearDepth(1.0);				
    glDepthFunc(GL_LESS);			
    glEnable(GL_DEPTH_TEST);			
    glShadeModel(GL_SMOOTH);			
    glCullFace(GL_BACK);    
    glEnable(GL_CULL_FACE);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();				 
    gluPerspective(45.0f,(GLfloat)Width/(GLfloat)Height,0.1f,100.0f);	
    glMatrixMode(GL_MODELVIEW);
}

void ReSizeGLScene(int Width, int Height)
{
    if (Height==0)				
	Height=1;
    glViewport(0, 0, Width, Height);		
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(45.0f,(GLfloat)Width/(GLfloat)Height,0.1f,100.0f);
    glMatrixMode(GL_MODELVIEW);
}

void triggerHandle (int button, int state, int x, int y)
{
	if (button == GLUT_LEFT_BUTTON) {  
		if (state == GLUT_DOWN) { 
		}
		if (state == GLUT_UP) {  
		   p.orientacion--;
		   glutPostRedisplay();
		}
	}

	if (button == GLUT_RIGHT_BUTTON) {  
		if (state == GLUT_DOWN) { 
		}
		if (state == GLUT_UP) {  
		   p.orientacion++;
		   glutPostRedisplay();
        }
	}
}

void DibujaProtagonista(){
    glPushMatrix();
    glTranslatef(p.x*2,p.y*2,0);  
    glScalef(0.5,0.5,0.5);
    
    glRotatef(p.orientacion*90.0,0,1,0);
    glRotatef(-90,1,0,0);
    modelo->AnimateModel(inicio_ani,fin_ani,0.7);
    //modelo_w->AnimateModel(inicio_ani,fin_ani,0.7);   //the sword texture is damaged
    glPopMatrix();    
    glEnable(GL_TEXTURE_2D); 
    glColor3f(1.0,1.0,1.0);
}



void DrawGLScene()
{
    frameStart();
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);		
    glLoadIdentity();				
    glTranslatef(0.0f,0.0f,-5.0f);             
    glRotatef(xrot,1.0f,0.0f,0.0f);		
    glRotatef(yrot,0.0f,1.0f,0.0f);		
    glRotatef(zrot,0.0f,0.0f,1.0f);		
    glPushMatrix();
    glScalef(0.25,0.25,0.25);
    glScalef(0.5,0.5,0.5);
    DibujaProtagonista();
    glPopMatrix();
    glPushMatrix();
    glTranslatef(-3,0,0);
    glScalef(0.25,0.25,0.25);
    glScalef(0.5,0.5,0.5);
    DibujaProtagonista();
    glPopMatrix();
    glPushMatrix();
    glTranslatef(-1.5,0,0);
    glScalef(0.25,0.25,0.25);
    glScalef(0.5,0.5,0.5);
    DibujaProtagonista();
    glPopMatrix();
    glPushMatrix();
    glTranslatef(1.5,0,0);
    glScalef(0.25,0.25,0.25);
    glScalef(0.5,0.5,0.5);
    DibujaProtagonista();
    glPopMatrix();
    glPushMatrix();
    glTranslatef(3,0,0);
    glScalef(0.25,0.25,0.25);
    glScalef(0.5,0.5,0.5);
    DibujaProtagonista();
    glPopMatrix();
    
//    glEnable(GL_BLEND);	
//	glDisable(GL_DEPTH_TEST);	
//	glColor3f(1,0,0);
//    glBlendFunc(GL_ONE, GL_ONE);		
//    cadena->glPrintString(500,450,buf,1);
//    cadena->glPrintString(500,450,buf,1);
//    cadena->scaleFont(2,2);
//    cadena->glPrintString(30,450,Nombrejuego,1);
//    cadena->glPrintString(30,450,Nombrejuego,1);
//    glDisable(GL_BLEND);	
//	glEnable(GL_DEPTH_TEST);
//	glBlendFunc(GL_DST_COLOR,GL_ZERO);	
	frameEnd();
    cadena->glPrintString(400,450,buf,1);
	cadena->glPrintString(30,450,Nombrejuego,1);
	
    glutSwapBuffers();
    sceDisplayWaitVblankStart ();
}

void keyPressed(unsigned char key, int x, int y) 
{
	switch(key){
		case 'x':			
 		     break;
       	case 'o':			
             break;
		case 'a':
			exit(0);                   
	    default:
		;
	}
}

void specialKeyPressed(int key, int x, int y) 
{

    switch (key) {    
    case GLUT_KEY_UP: 
   	break;

    case GLUT_KEY_DOWN: 
      break;

    case GLUT_KEY_LEFT: 
      break;
    
    case GLUT_KEY_RIGHT: 
      break;

    case GLUT_KEY_HOME: 
	break;
	
    default:
	break;

   }
}

void specialKeyReleased(int key, int x, int y) 
{

    switch (key) {    
    case GLUT_KEY_UP: 
 
	break;

    case GLUT_KEY_DOWN: 
 
    break;

    case GLUT_KEY_LEFT: 

    break;
    
    case GLUT_KEY_RIGHT: 

    break;

    case GLUT_KEY_HOME: 
	break;
	
    default:
	break;
    }	
}
  
int main(int argc, char **argv) 

{ 
    scePowerSetClockFrequency(333, 333, 166);
    char filename;
    cadena=new glPrint;
    p.x=0;
    p.y=0;
    p.orientacion=0;
    modelo = new CMD2Model;
    modelo_w = new CMD2Model;
    glutInit(&argc, argv);  
    glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_ALPHA | GLUT_DEPTH);  
    glutInitWindowSize(480, 272);
    glutInitWindowPosition(0, 0);  
    window = glutCreateWindow("3D ~ GDS demo program");  
    glutDisplayFunc(&DrawGLScene);  
    glutIdleFunc(&DrawGLScene);
    glutReshapeFunc(&ReSizeGLScene);
    glutKeyboardFunc(&keyPressed);
    glutSpecialFunc(&specialKeyPressed);
    glutSpecialUpFunc(&specialKeyReleased);
    glutMouseFunc(&triggerHandle);
    InitGL(480, 272);
    sprintf( buf, "fps:%d\0",60 );
    sprintf( Nombrejuego, "Demo program\0");
    cadena->BuildFont();
    cadena->scaleFont(2,2);
    modelo->Load("knight/tris.md2","knight/knight.pcx"); 
    modelo_w->Load("knight/weapon.md2","weapon/weapon.pcx"); 
    glutMainLoop();  
    return 1;
}

